## START: Set by rpmautospec
## (rpmautospec version 0.3.0)
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

# Sphinx-generated HTML documentation is not suitable for packaging; see
# https://bugzilla.redhat.com/show_bug.cgi?id=2006555 for discussion.
#
# We can generate PDF documentation as a substitute.
#
# However, currently we do not have all the necessary dependencies:
#   No matching package to install: 'python3dist(myst-nb) = 0.12.2'
#   No matching package to install: 'python3dist(nbconvert) < 6'
#   No matching package to install: 'python3dist(nbsite) >= 0.6.1'
#   No matching package to install: 'python3dist(panel)'
%bcond_with doc_pdf

Name:           python-param
# Update this on every new upstream release.  Consult the file param/.version
# in the PyPI release tarball, or check the commit hash corresponding to the
# release tag on GitHub.
%global shortcommit 782a03c
Version:        1.13.0
Release:        %autorelease
Summary:        Make your Python code clearer and more reliable by declaring Parameters

License:        BSD-3-Clause
# The GitHub tarball contains documentation, examples, and tests; the PyPI
# tarball does not. See:
# https://github.com/holoviz/param/issues/219
# https://github.com/holoviz/param/issues/103
URL:            https://github.com/holoviz/param
Source0:        %{url}/archive/v%{version}/param-%{version}.tar.gz

BuildArch:      noarch

# https://fedoraproject.org/wiki/Changes/EncourageI686LeafRemoval
ExcludeArch:    %{ix86}

BuildRequires:  python3-devel

%if %{with doc_pdf}
BuildRequires:  make
BuildRequires:  python3dist(sphinx)
BuildRequires:  python3-sphinx-latex
BuildRequires:  latexmk
%endif

BuildRequires:  python3dist(pytest)

%global common_description %{expand:
Param is a library providing Parameters: Python attributes extended to have
features such as type and range checking, dynamically generated values,
documentation strings, default values, etc., each of which is inherited from
parent classes if not specified in a subclass.

Documentation and examples may be found at https://param.holoviz.org.}

%description %{common_description}


%package -n python3-param
Summary:        %{summary}
%py_provides python3-numbergen

# The file param/version.py is derived from a forked copy of
# https://github.com/pyviz-dev/autover. See the comments at the top of the file
# for details. Note that we cannot unbundle this library because it is in the
# public API, so the fork matters.
Provides:       bundled(python3dist(autover)) = 0.2.5

%description -n python3-param %{common_description}


%package doc
Summary:        Documentation and examples for param

%description doc %{common_description}


%prep
%autosetup -n param-%{version}

# Imitate the PyPI release process.
cat > param/.version <<EOF
{"git_describe": "v%{version}-0-g%{shortcommit}", "version_string": "%{version}"}
EOF

# Do not generate test dependencies for linting or coverage:
sed -r -i '/\b(flake8|coverage)\b/d' setup.py


%generate_buildrequires
%pyproject_buildrequires -x tests%{?with_doc_pdf:,doc}


%build
%set_build_flags
%pyproject_wheel

%if %{with doc_pdf}
sphinx-build -b latex %{?_smp_mflags} docs %{_vpath_builddir}/_latex
%make_build -C %{_vpath_builddir}/_latex LATEXMKOPTS='-quiet'
%endif


%install
%pyproject_install
%pyproject_save_files param


%check
%pytest


%files -n python3-param -f %{pyproject_files}
# pyproject-rpm-macros handles LICENSE.txt; verify with “rpm -qL -p …”
%{python3_sitelib}/numbergen/


%files doc
%license LICENSE.txt
%doc README.md
%doc examples
%if %{with doc_pdf}
%doc {_vpath_builddir}/_latex/param.pdf
%endif


%changelog
* Wed Mar 15 2023 Benjamin A. Beasley <code@musicinmybrain.net> 1.13.0-1
- Update to 1.13 (close RHBZ#2178047)

* Fri Jan 20 2023 Fedora Release Engineering <releng@fedoraproject.org> 1.12.3-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_38_Mass_Rebuild

* Mon Dec 19 2022 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.3-3
- Leaf package: remove i686 support

* Mon Dec 19 2022 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.3-2
- Indicate dirs. in files list with trailing slashes

* Fri Dec 09 2022 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.3-1
- Update to 1.12.3 (close RHBZ#2152096)

* Thu Nov 24 2022 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.2-6
- Update License to SPDX

* Wed Nov 23 2022 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.2-5
- Minor spec file typo fix

* Mon Aug 22 2022 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.2-4
- Parallelize sphinx-build

* Fri Jul 22 2022 Fedora Release Engineering <releng@fedoraproject.org> 1.12.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Tue Jun 21 2022 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.2-2
- Bump EVR to align with F36

* Tue Jun 21 2022 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.2-1
- Update to 1.12.2 (close RHBZ#2099367)

* Fri Jun 17 2022 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.0-8
- Updated patch file for PR#608

* Tue Jun 14 2022 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.0-7
- Preserve existing Random seed behavior in Python 3.11 (fix RHBZ#2093926)

* Mon Jun 13 2022 Python Maint <python-maint@redhat.com> 1.12.0-6
- Rebuilt for Python 3.11

* Fri Jan 21 2022 Fedora Release Engineering <releng@fedoraproject.org> 1.12.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Fri Jan 07 2022 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.0-4
- Prefer python3dist(…) to %%%%{py3_dist …}

* Tue Dec 28 2021 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.0-3
- Do not generate test dependencies for linting or coverage

* Fri Nov 26 2021 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.0-2
- Reduce LaTeX PDF build verbosity

* Mon Nov 22 2021 Benjamin A. Beasley <code@musicinmybrain.net> 1.12.0-1
- Initial package
